<?php
/* $Id$ */
/*
	sg_log.inc
	All rights reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	1. Redistributions of source code must retain the above copyright notice,
	   this list of conditions and the following disclaimer.

	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/

$auth_privilege = 'auth_email';

$pgtitle = "RedPort email server: Tools";

$omit_nocacheheaders = true;
require_once("guiconfig.inc");


if (file_exists("/usr/local/pkg/xgate.inc")) {
   require_once("/usr/local/pkg/xgate.inc");
}

$selfpath = "/xgate/xgate_tools.php";

if ( $_POST ) {
    switch($_POST['Submit']) {
	case 'Start':
	    xgate_start_transfer();
	    break;
	case 'Stop':
	    xgate_stop_transfer();
	    break;
	case 'Break':
	    xgate_break_transfer();
	    break;
	case 'Purge Restart Files':
	    xgate_purge_restart();
	    $savemsg = "Restart files and outbox have been purged";
	    break;
	case 'Restart Service':
	    xgate_restart();
	    $savemsg = "Email service restarted";
	    break;
	case 'Broadcast Message':
	    xgate_broadcast_msg($_POST['broad_account'], $_POST['subject'], $_POST['mesg']);
	    $savemsg = "Broadcast message to " . $_POST['broad_account'] . " has been sent";
	    break;
	case 'Delete Sub Accounts':
	    xgate_del_sub($_POST['del_account']);
	    $savemsg = "Sub accounts for " . $_POST['del_account'] . " have been zapped";
	    break;
	case 'Import Sub Accounts':
	    if ( is_uploaded_file($_FILES['import_conffile']['tmp_name']) ) {
	        $stat = xgate_import_sub($_POST['import_account'], $_FILES['import_conffile']['tmp_name']);
		if ( $stat === true ) {
		    $savemsg = "Sub accounts imported into " . $_POST['import_account'];
		} else {
		    $input_errors[] = $stat;
		}
	    } else {
	        $input_errors[] = "The configuration file could not be restored do to file upload errors";
	    }
	    break;
	case 'Download Configuration':
	    $tgz = xgate_spool_tgz();
	    $fn = $_POST['download_conffile'];
	    if ( empty($fn) ) {
	        $fn = basename($tgz);
	    }
	    $fs = filesize($tgz);
            header("Content-Type: application/octet-stream");
            header("Content-Disposition: attachment; filename=$fn");
            header("Content-Length: $fs");
            readfile($tgz);
	    unlink($tgz);
	    exit;
	case 'Restore Configuration':
	    if ( is_uploaded_file($_FILES['restore_conffile']['tmp_name']) ) {
	        $stat = xgate_spool_restore($_FILES['restore_conffile']['tmp_name']);
		if ( $stat === true ) {
		    $savemsg = "Email conguration restored";
		} else {
		    $input_errors[] = $stat;
		}
	    } else {
	        $input_errors[] = "The configuration file could not be restored do to file upload errors (no file specified)";
	    }
	    break;
	case 'Upgrade':
	    if ( is_uploaded_file($_FILES['upgrade_conffile']['tmp_name']) ) {
	        $stat = xgate_upgrade($_FILES['upgrade_conffile']['tmp_name']);
		if ( $stat === true ) {
		    $savemsg = "Upgrade completed";
		} else {
		    $input_errors[] = $stat;
	 	}
	    } else {
	        $input_errors[] = "The configuration file could not be restored do to file upload errors (no file specified)";
	    }
	    break;
    }
}

include("head.inc");

?>

<!-- HTML -->
<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<?php include("fbegin.inc"); ?>
<p class="pgtitle"><?php echo "$pgtitle"; ?></p>
<form action="<?php echo $selfpath; ?>" method="post" enctype="multipart/form-data">
<?php if ($input_errors) print_input_errors($input_errors); ?>
<?php if ($savemsg) print_info_box($savemsg); ?>
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<!-- Tabs -->
  <tr>
    <td>
<?php
        $tab_array = array();
        $tab_array[] = array(gettext("General"), 		false, "/pkg_edit.php?xml=xgate.xml&amp;id=0");
        $tab_array[] = array(gettext("Connection"),          	false, "/pkg_edit.php?xml=xgate_connection.xml&amp;id=0");
        $tab_array[] = array(gettext("Filters"),     		false, "/pkg_edit.php?xml=xgate_filters.xml&amp;id=0");
        $tab_array[] = array(gettext("Primary Accounts"),       false, "/pkg.php?xml=xgate_primary_accounts.xml");
        $tab_array[] = array(gettext("Sub Accounts"),         	false, "/pkg.php?xml=xgate_sub_accounts.xml");
        $tab_array[] = array(gettext("Spool"),              	false,  "/xgate/xgate_spool.php");
        $tab_array[] = array(gettext("Tools"),              	true,  "$selfpath");
        $tab_array[] = array(gettext("BigMail"),              	false,  "/xgate/xgate_bigmail.php");
        $tab_array[] = array(gettext("Logs"),              	false,  "/xgate/xgate_logs.php");
        display_top_tabs($tab_array);
?>
    </td>
  </tr>
  <tr>
    <td>
      <div id="mainarea">
        <table class="tabcont" width="100%" border="0" cellpadding="0" cellspacing="0">
          <tr>
            <td>

<?php
        # Subtabs
        $tab_array = array();
        $tab_array[] = array(gettext("Start"),   "Start transfer now");
        $tab_array[] = array(gettext("Stop"),    "Stop transfer now");
        $tab_array[] = array(gettext("Break"),   "Disconnect now");
        $tab_array[] = array(gettext("Purge Restart Files"),   "Purge restart files. Deletes items in Outbox");
        $tab_array[] = array(gettext("Restart Service"), "Restart email service");

    	$indx = 0;
	echo "<big>";
	echo " | ";
        foreach ($tab_array as $ta) {
            echo "<input type=\"submit\" name=\"Submit\" value=\"{$ta[0]}\" title=\"{$ta[1]}\"/>";
   	    echo " | ";
        }
	echo "</big>";
?>
            </td>
          </tr>
          <tr>
            <td>
    	       <table class='tabcont' align='center' width='100%' border='0' cellpadding='6' cellspacing='0'>

	       <tr>
                   <td colspan="2" class="listtopic">Broadcast Message</td>
               </tr>
               <tr>
                   <td width="22%" valign="baseline" class="vncell">&nbsp;</td>
                   <td width="78%" class="vtable">
		       <p/>Broadcast message to all users or to users bound to a primary account
		       <br/><br/>
		       <p/>Account: <?php spit_out_select_primary_accounts(true,"broad_account"); ?>
                       <p>Subject: <input name="subject" type="text" size="70"></p>
                       <p><textarea name="mesg" cols=60 rows=10></textarea></p>
                       <p><input name="Submit" type="submit" class="formbtn" id="Broadcast" value="Broadcast Message"></p>
                   </td>
		</tr>
               <tr>
                   <td colspan="2" class="list" height="12">&nbsp;</td>
               </tr>

	       <tr>
                   <td colspan="2" class="listtopic">Delete Sub Accounts</td>
               </tr>
               <tr>
                   <td width="22%" valign="baseline" class="vncell">&nbsp;</td>
                   <td width="78%" class="vtable">
		       <p/>Remove all Sub Accounts for a Specific Primary Account
		       <br/><br/>
		       <p/>Primary Account: <?php spit_out_select_primary_accounts(true, "del_account"); ?>
                       <p><input name="Submit" type="submit" class="formbtn" id="zapsubacct" value="Delete Sub Accounts"></p>
                   </td>
		</tr>
               <tr>
                   <td colspan="2" class="list" height="12">&nbsp;</td>
               </tr>

	       <tr>
                   <td colspan="2" class="listtopic">Import Sub Accounts</td>
               </tr>
               <tr>
                   <td width="22%" valign="baseline" class="vncell">&nbsp;</td>
                   <td width="78%" class="vtable">
		       <p/>Import CSV formatted file consisting of 3 columns containing  "username", "password", "users real name" as sub accounts to be assigned to a specific primary account
		       <br/><br/>
		       <p/>Primary Account: <?php spit_out_select_primary_accounts(false, "import_account"); ?>
                       <p><input name="import_conffile" type="file" class="formfld" id="import_conffile" size="40"></p>
                       <p><input name="Submit" type="submit" class="formbtn" id="importsubacct" value="Import Sub Accounts"></p>
                   </td>
		</tr>
               <tr>
                   <td colspan="2" class="list" height="12">&nbsp;</td>
               </tr>

	       <tr>
	           <td colspan='2' class='listtopic'>Backup Configuration</td>
	       </tr>
               <tr>
                   <td width="22%" valign="baseline" class="vncell">&nbsp;</td>
                   <td width="78%" class="vtable">
                      <p/>Click this button to download backup of email configuration and mail spool folder<br /><br />
                       <p>Enter filename: <input name="download_conffile" type="text" value="<?php echo "backup" . date('U') . ".tgz"; ?>" size="40"></p>
                      <p><input name="Submit" type="submit" class="formbtn" id="download" value="Download Configuration"></p>
                   </td>
               </tr>
               <tr>
                   <td colspan="2" class="list" height="12">&nbsp;</td>
               </tr>

	       <tr>
                   <td colspan="2" class="listtopic">Restore Configuration</td>
               </tr>
               <tr>
                   <td width="22%" valign="baseline" class="vncell">&nbsp;</td>
                   <td width="78%" class="vtable">
                       <p/>Restore email configuration and mail spool folder from a previous backup<br/><br/>		
                       <p><input name="restore_conffile" type="file" class="formfld" id="restore_conffile" size="40"></p>
                       <p><input name="Submit" type="submit" class="formbtn" id="restore" value="Restore Configuration"></p>
                   </td>
		</tr>
               <tr>
                   <td colspan="2" class="list" height="12">&nbsp;</td>
               </tr>

	       <tr>
                   <td colspan="2" class="listtopic">Upgrade Email</td>
               </tr>
               <tr>
                   <td width="22%" valign="baseline" class="vncell">&nbsp;</td>
                   <td width="78%" class="vtable">
		       <p/>Upload and install new email software. Note: Image must be in *.tgz format
		       <br/><br/>
                       <p><input name="upload_conffile" type="file" class="formfld" id="upload_conffile" size="40"></p>
                       <p><input name="Submit" type="submit" class="formbtn" id="upgrade" value="Upgrade"></p>
                   </td>
		</tr>

	       </table>

            </td>
          </tr>
        </table>
      </div>
    </td>
  </tr>
</table>
</form>

<?php include("fend.inc"); ?>

<script type="text/javascript"> 
  NiftyCheck(); 
  Rounded("div#mainarea","bl br","#FFF","#eeeeee","smooth");
</script>
</body>
</html>

<?php

function spit_out_select_primary_accounts($all, $name)
{
    $users = get_primary_users();
    $ret = "<select name=\"$name\">";
    if ( $all ) {
        $ret .= "<option value=\"All\">All</option>";
    }
    foreach ($users as $user ) {
        $ret .= "<option value=\"$user\">$user</option>";
    }
    $ret .= "</select>";
    echo $ret;
}


?>
